VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   0  'Kein
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4680
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows-Standard
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Dieser Source stammt von http://www.vb-fun.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !

Option Explicit

'=== DirectDraw-Initialisations-Variablen ===
Dim DX7 As New DirectX7
Dim DD7 As DirectDraw7
Dim SurfaceDesc As DDSURFACEDESC2
Dim PrimarySurface As DirectDrawSurface7
Dim BackBuffer As DirectDrawSurface7
Dim bmpBackground(2) As DirectDrawSurface7

Const min_pos As Long = 0
Const max_pos As Long = 3000

Dim x_pos As Long
Dim move_rate As Integer

Dim running As Boolean

Private Sub Form_Load()
  Dim srcrect As RECT
  Dim tile_pos As Long
  Dim screen_x As Long
  Dim i As Single
  
  Me.Show
  Me.Refresh
  
  Initialization   'DirectDraw initialisieren
  BitmapLaden      'Laden der Bitmaps
  
  x_pos = 1400
  move_rate = 0
  
  running = True
  
  Do
    'Bildposition bewegen
    x_pos = x_pos + move_rate
    If x_pos < min_pos Then
      x_pos = min_pos
      move_rate = 0
    End If
    If x_pos > max_pos Then
      x_pos = max_pos
      move_rate = 0
    End If
    
    'Background zeichnen
    'schleife ber die Kacheln
    For i = 0 To 2
      'Position der sichtbaren Kacheln berechnen
      tile_pos = 400 * i + (x_pos \ 1200) * 1200
      If (tile_pos + 1200) < (x_pos + 640) Then _
            tile_pos = tile_pos + 1200
      
      'ist das Objekt im Bild ?
      If (tile_pos + 400) >= x_pos Then
        
        'ja, Abstand zur linken Ecke des Bildschirm berechnen
        screen_x = tile_pos - x_pos
        
        'Objekt clippen wenn notwendig
        With srcrect
          .Left = 0: .Top = 0
          .Right = 400: .Bottom = 480
        End With
        
        'Test auf Clipping
        If screen_x < 0 Then
          srcrect.Left = srcrect.Left - screen_x
          screen_x = 0
        Else
          If (screen_x + srcrect.Right) > 640 Then
            srcrect.Right = 640 - screen_x
          End If
        End If
        
        'Objekt auf Bildschirm zeichnen
        BackBuffer.BltFast screen_x, 0, bmpBackground(i), _
              srcrect, DDBLTFAST_WAIT
      End If
    Next i
    
    BackBuffer.SetForeColor vbRed
    BackBuffer.SetFont Me.Font
    BackBuffer.DrawText _
          10, 10, "DirectDraw und Hintergrund-Scrolling ", False
    BackBuffer.DrawText _
          10, 30, "<Esc> beendet das Programm", False
    BackBuffer.DrawText _
          10, 50, "Cursortasten Links/Rechts fr scrollen", False
    BackBuffer.DrawText 10, 70, "mehrfaches Bettigen der " & _
          "Cursortasten beschleunigt das Scrollen", False
    
    'Inhalt des BackBuffers in den PrimarySurface kopieren
    PrimarySurface.Flip Nothing, DDFLIP_WAIT
    
    'BackBuffer lschen
    'da ansonsten alter Speicherinhalt angezeigt wird
    ClearBuffer vbBlack
    
    DoEvents
  Loop While running
  
  Terminate
End Sub

Private Sub Form_KeyPress(KeyAscii As Integer)
  If (KeyAscii = vbKeyEscape) Then
    running = False
  End If
End Sub

Private Sub Form_KeyUp(KeyCode As Integer, Shift As Integer)
  If KeyCode = vbKeyLeft Then
    If move_rate > -20 Then
      move_rate = move_rate - 5
    End If
  End If
  If KeyCode = vbKeyRight Then
    If move_rate < 20 Then
      move_rate = move_rate + 5
    End If
  End If
End Sub

Sub Initialization()             'DirectDraw wird initialisiert
    
  'Holen wir uns den Zugriff auf das DirectDraw-Objekt.
  'Der leere String-Parameter bedeutet,
  'dass der aktive Bildschirmtreiber benutzt werden soll
  Set DD7 = DX7.DirectDrawCreate("")
  'Die Anwendung soll im VollbildModus laufen
  DD7.SetCooperativeLevel Me.hWnd, DDSCL_EXCLUSIVE Or _
        DDSCL_FULLSCREEN Or DDSCL_ALLOWREBOOT
  'Auflsung und Farbtiefe deklarieren
  DD7.SetDisplayMode 640, 480, 16, 0, DDSDM_DEFAULT
  'Beschreibung des PrimarySurface mit einem BackBuffer
  With SurfaceDesc
      .lFlags = DDSD_CAPS Or DDSD_BACKBUFFERCOUNT
      .ddsCaps.lCaps = DDSCAPS_PRIMARYSURFACE Or _
            DDSCAPS_FLIP Or DDSCAPS_COMPLEX
      .lBackBufferCount = 1
  End With
  'PrimarySurface initialisieren auf dem alles abgebildet wird
  Set PrimarySurface = DD7.CreateSurface(SurfaceDesc)
  
  'Fr die Beschreibung des Backbuffers bentigen wir nur
  'den ddsCaps-Bereich
  SurfaceDesc.ddsCaps.lCaps = DDSCAPS_BACKBUFFER
  'BackBuffer initialisieren in dem alles gezeichnet und dann
  'in die PrimarySurface ge'flipt wird
  Set BackBuffer = _
        PrimarySurface.GetAttachedSurface(SurfaceDesc.ddsCaps)
End Sub

Sub BitmapLaden()
  Dim BmpDesc As DDSURFACEDESC2
      
  BmpDesc.lFlags = DDSD_CAPS Or DDSD_HEIGHT Or DDSD_WIDTH
  BmpDesc.ddsCaps.lCaps = DDSCAPS_OFFSCREENPLAIN
  
  BmpDesc.lWidth = 400
  BmpDesc.lHeight = 480
  
  Set bmpBackground(0) = _
      DD7.CreateSurfaceFromFile(App.Path & "\city1.bmp", BmpDesc)
  Set bmpBackground(1) = _
      DD7.CreateSurfaceFromFile(App.Path & "\city2.bmp", BmpDesc)
  Set bmpBackground(2) = _
      DD7.CreateSurfaceFromFile(App.Path & "\city3.bmp", BmpDesc)
End Sub

Sub ClearBuffer(Color As Long)
  Dim destrect As RECT
  
  With destrect
    .Bottom = 480
    .Left = 0
    .Right = 640
    .Top = 0
  End With
  BackBuffer.BltColorFill destrect, Color
End Sub

Function GetTime() As Long
  GetTime = DX7.TickCount
End Function

Sub Terminate()
  Dim i As Single
  For i = 0 To 2
      Set bmpBackground(i) = Nothing
  Next i
  'alte Auflsung wiederherstellen
  DD7.RestoreDisplayMode
  DD7.SetCooperativeLevel Me.hWnd, DDSCL_NORMAL
  Set PrimarySurface = Nothing
  Set DD7 = Nothing
  Set DX7 = Nothing
  End
End Sub

